<?PHP
/*
このサンプルプログラムの取り決め
●画像パネルは縦横3×3の9枚
●画像は「煮卵」と「煮卵に似た何か」の二種類
●その二種類の画像はどちらも9枚ずつ用意されている
*/

####niCAPTCHA設定
#煮卵画像取得数（2～4画像）
$IMG_MIN = 2;
$IMG_MAX = 4;


#セッションを利用
session_start();

#煮卵画像取得数をランダムで決定
$nitamago_count = rand($IMG_MIN, $IMG_MAX);

#画像パネル配列初期化（パネル数は縦3、横3の9枚とする）
$tbl_panel = array_fill(0, 9, 0);

#パネル番号を左上から右に順に0～8で割り当てる
$tbl_panel_number = array(0, 1, 2, 3, 4, 5, 6, 7, 8);

#シャッフルしてから煮卵画像の数だけパネルを取得
#取得したパネルに、後で煮卵の画像を貼り付ける
shuffle($tbl_panel_number);
$tbl_panel_nitamago = array_slice($tbl_panel_number, 0, $nitamago_count);

#煮卵画像位置の保存
$ans = 0;
foreach ($tbl_panel_nitamago as $value) {
	#パネルを9ビット整数に見立て、煮卵の位置に1を立てる
	$ans += 1 << $value;
	#ランダムに取得したパネル番号の位置に、煮卵フラグを入れる
	$tbl_panel[$value] = 1;
}
#算出した答えを格納
$_SESSION['ans'] = $ans;


####パネル画像の作成
#niCAPTCHAキャンバスを白背景で用意
$canvas = imagecreatetruecolor(300, 300);
imagefill($canvas, 0, 0, imagecolorallocate($canvas, 255, 255, 255));

#正誤画像ファイル名を配列に用意
$tbl_prefix = array('shiri_', 'tamago_');
#画像ファイル番号を配列に用意
$tbl_img_number = array(1, 2, 3, 4, 5, 6, 7, 8, 9);
#画像ファイル番号配列をシャッフルすることで使用する画像を重複しないランダムにする
shuffle($tbl_img_number);

#パネルに画像を貼り付けてキャンバスを完成させる
foreach ($tbl_panel as $key => $value) {
	$im    = imagecreatefromjpeg(sprintf('./niCAPTCHAimg/%s%02d.jpg', $tbl_prefix[$value], $tbl_img_number[$key]));
	$dst_x = $key % 3 * 100 + 1;
	$dst_y = floor($key / 3) * 100 + 1;
	imagecopyresampled($canvas, $im, $dst_x, $dst_y, 0, 0, 98, 98, 100, 100);
}


#出力・後処理
imagedestroy($im);

header('Content-type: image/jpeg');
imagejpeg($canvas);

imagedestroy($canvas);

?>
